
XIncludeFile "Drawing3D.pbi"


Enumeration
	#Window
	#Gadget
	#ListViewGadget
	#Image
	#Image3D
	#ButtonGadget
	#RealImage
EndEnumeration


Procedure UpdateCanvasGadget(Gadget, Image.i=#Null)
	
	Static MouseX.i, MouseY.i, Distance.f = 700
	Protected X.i, Y.i, Z.i, N, W.i, R.i, Phi.i, R1.f, R2.f, Dim Y.f(40, 40), Dim Color.l(40, 40)
	Protected Time1.q, Time2.q, Frequency.q
	
	QueryPerformanceFrequency_(@Frequency)
	QueryPerformanceCounter_(@Time1)
	
	If Image
		StartDrawing3D(ImageOutput(Image))
		Drawing3DBackground($00FFFFFF)
	Else
		StartDrawing3D(CanvasOutput(Gadget))
		Drawing3DBackground($FFFFFFFF)
		Distance * Pow(1.1, GetGadgetAttribute(Gadget, #PB_Canvas_WheelDelta))
		If GetGadgetAttribute(Gadget, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton  
			Drawing3DRotation(Radian(GetGadgetAttribute(Gadget, #PB_Canvas_MouseY)-MouseY)*15, Radian(GetGadgetAttribute(Gadget, #PB_Canvas_MouseX)-MouseX)*15, 0, #PB_Relative)
		EndIf
		MouseY = GetGadgetAttribute(Gadget, #PB_Canvas_MouseY)
		MouseX = GetGadgetAttribute(Gadget, #PB_Canvas_MouseX)
	EndIf
	
	Drawing3DPosition(0, 0, -Distance)
	
	Select GetGadgetState(#ListViewGadget)
			
		Case 0
			DrawPlane3D(0, 0, 0, 340, 200,  0,  0,  0, $80FF0000)
			DrawPlane3D(0, 0, 0, 340, 200, 90, 90,  0, $800000FF)
			DrawPlane3D(0, 0, 0, 340, 200, 90,  0, 90, $8000FF00)
			
		Case 1
			
			Drawing3DMode(#Drawing3D_Outline)
			DrawBox3D(0, 0, 0, 200, 200, 200, 0, 0, 0, $FF000000)
			Drawing3DMode(#Drawing3D_Default)
			
		Case 2
			
			Drawing3DLight(1, 0, 0, $FFFFFF00)
			Drawing3DLight(-1, 0, 0, $FF00FFFF)
			
			DrawBox3D(0, 0, 0, 200, 200, 200, 0, 0, 0, $FF000000)
			
		Case 3
			
			Drawing3DLight(0.5, 1, 1, $FFFFFFFF)
			
			DrawBox3D(0, 0, 0, 100, 200, 300, 0, 0, 0, $C000C060)
			DrawBox3D(0, 0, 0, 100, 200, 300, 30, 45, 15, $C08000C0)
			
		Case 4
			
			Drawing3DLight(0.5, 1, -1, $FFFFFFFF)
			
			DrawTriangle3D(-100, 100, 100, 100, 100, -100, 100, -100, 100, $FF00C000, $FFC00000, $FF0000C0)
			DrawTriangle3D(-100, 100, 100, 100, -100, 100, -100, -100, -100, $FF00C000, $FF0000C0, $FF00C0C0)
			DrawTriangle3D(-100, 100, 100, -100, -100, -100, 100, 100, -100, $FF00C000, $FF00C0C0, $FFC00000)
			DrawTriangle3D(100, -100, 100, 100, 100, -100, -100, -100, -100, $FF0000C0, $FFC00000, $FF00C0C0)
			DrawLine3D(90, -90, -90, -90, -90, 90, $FF00C000, $FFC00000)
			DrawLine3D(-90, -90, 90, -90, 90, -90, $FFC00000, $FF0000C0)
			DrawLine3D(-90, 90, -90, 90, -90, -90, $FF0000C0, $FF00C000)
			DrawLine3D(90, -90, -90, 90, 90, 90, $FF00C000, $FF00C0C0)
			DrawLine3D(-90, -90, 90, 90, 90, 90, $FFC00000, $FF00C0C0)
			DrawLine3D(-90, 90, -90, 90, 90, 90, $FF0000C0, $FF00C0C0)
			
		Case 5
			
			DrawImage3D(#Image3D, 0, 0, 0, 400, 400, 0, 0, 0)
			
		Case 6
			
			RandomSeed(1)
			For Y = -100 To 100
				For X = -100 To 100
					Z = Random(100)-50
					DrawPoint3D(X, Y, Z, $FF000000)
				Next
			Next
			
		Case 7
			
			Drawing3DLight(0.5, 1, 1, $40FFFFFF)
			
			DrawBox3D(0, 0, 0, 100, 30, 30, 0, 0, 0, $FF404040)
			DrawBox3D(-75, 0, 0, 50, 30, 30, 0, 0, 0, $FF808000)
			DrawBox3D(75, 0, 0, 50, 30, 30, 0, 0, 0, $FF000080)
			
			RandomSeed(5)
			For N = 1 To 50
				Phi = Random(359)
				R = Random(100)+30
				For W = 0 To 359 Step 5
					R1 = (1-Cos(Radian(W)))*R
					R2 = (1-Cos(Radian(W+5)))*R
					DrawLine3D(-Sin(Radian(W))*R*2, R1*Sin(Radian(Phi)), R1*Cos(Radian(Phi)), -Sin(Radian(W+5))*R*2, R2*Sin(Radian(Phi)), R2*Cos(Radian(Phi)), RGBA(255*W/360, 255*(360-W)/360, 255*(360-W)/360, 192))
				Next
			Next
			
		Case 8
			
			Drawing3DLight(0.5, 1, 1, $20FFFFFF)
			For Z = -20 To 20
				For X = -20 To 20
					Y(X+20,Z+20) = Exp(-X*X/100-Z*Z/100)*(X+Z/4)/5
					If Y(X+20,Z+20) < 0
						Color(X+20,Z+20) = RGBA(0, 128+128*Y(X+20,Z+20), -255*Y(X+20,Z+20), 255)
					Else
						Color(X+20,Z+20) = RGBA(255*Y(X+20,Z+20), 128+128*Y(X+20,Z+20), 0, 255)
					EndIf
					Y(X+20,Z+20) * 200
				Next
			Next
			For Z = -20 To 19
				For X = -20 To 19
					DrawTriangle3D(X*10, Y(X+20,Z+20), Z*10, (X+1)*10, Y(X+21,Z+20), Z*10, X*10, Y(X+20,Z+21), (Z+1)*10, Color(X+20,Z+20), Color(X+21,Z+20), Color(X+20,Z+21))
					DrawTriangle3D((X+1)*10, Y(X+21,Z+21), (Z+1)*10, X*10, Y(X+20,Z+21), (Z+1)*10, (X+1)*10, Y(X+21,Z+20), Z*10, Color(X+21,Z+21), Color(X+20,Z+21), Color(X+21,Z+20))
				Next
			Next
			
	EndSelect
	
	StopDrawing3D()
	
	QueryPerformanceCounter_(@Time2)
	SetWindowTitle(#Window, StrF((Time2-Time1)/Frequency*1000,3))
	
EndProcedure



UsePNGImageDecoder()
UsePNGImageEncoder()

CatchImage(#Image, ?Image)
CreateImage3D(#Image3D, #Image)


OpenWindow(#Window, 0, 0, 900, 600, "", #PB_Window_MinimizeGadget|#PB_Window_ScreenCentered)
CanvasGadget(#Gadget, 10, 10, 580, 580, #PB_Canvas_Border|#PB_Canvas_Keyboard)
Frame3DGadget(#PB_Any, 600, 10, 290, 190, "Szenenauswahl")
ListViewGadget(#ListViewGadget, 610, 30, 270, 160)
	AddGadgetItem(#ListViewGadget, -1, "Drei sich durchdringende Flchen")
	AddGadgetItem(#ListViewGadget, -1, "Wrfel aus Linien")
	AddGadgetItem(#ListViewGadget, -1, "Belichteter Wrfel")
	AddGadgetItem(#ListViewGadget, -1, "Zwei durchdringende Quader")
	AddGadgetItem(#ListViewGadget, -1, "Tetraeder mit verschiedenen Eckfarben")
	AddGadgetItem(#ListViewGadget, -1, "Texturflche")
	AddGadgetItem(#ListViewGadget, -1, "Punkte")
	AddGadgetItem(#ListViewGadget, -1, "Anwendungsbeispiel: Magnet & Feldlinien")
	AddGadgetItem(#ListViewGadget, -1, "Anwendungsbeispiel: 3D-Funktion")
SetGadgetState(#ListViewGadget, 3)
TextGadget(#PB_Any, 610, 210, 290, 40, "Left mouse to rotate the scene"+#LF$+"Mouse wheel to zoom")
Drawing3DRotation(30, 30, 0)
UpdateCanvasGadget(#Gadget)


ButtonGadget(#ButtonGadget, 610, 250, 190, 30, "Save real 32Bit-Image")

Define FileName.s

Repeat
	
	Select WaitWindowEvent()
			
		Case #PB_Event_CloseWindow
			End
			
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #Gadget, #ListViewGadget
					UpdateCanvasGadget(#Gadget)
				Case #ButtonGadget
					CreateImage(#RealImage, 600, 600, 32|#PB_Image_Transparent)
					UpdateCanvasGadget(#Gadget, #RealImage)
					FileName = SaveFileRequester("Save", "", "*.png|*.PNG", 1)
					If FileName
						SaveImage(#RealImage, FileName, #PB_ImagePlugin_PNG)
					EndIf
			EndSelect
			
	EndSelect
	
ForEver


DataSection
	Image:
	IncludeBinary "Image.png"
EndDataSection

; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 168
; FirstLine = 137
; Folding = --
; EnableXP
; DisableDebugger
; EnableCompileCount = 113
; EnableBuildCount = 0